import { LockManager } from "@eventicle/eventicle-utilities";
import { PsqlEventDataStore } from "./index";
export declare class PSQLLockManager<E extends Error> implements LockManager {
    readonly db: PsqlEventDataStore<E>;
    constructor(db: PsqlEventDataStore<E>);
    tryLock<T>(id: string, onLock: () => Promise<T>, teardown: () => void): Promise<T>;
    withLock<T>(id: string, onLock: () => Promise<T>, teardown: () => void): Promise<T>;
    private internalLock;
    private maybeOutputLockDebug;
}
